function getContentBrowser(){
  var windowMediator = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                       .getService(Components.interfaces.nsIWindowMediator);
  var topWindowOfType = windowMediator.getMostRecentWindow("navigator:browser");
  if(topWindowOfType) return topWindowOfType.document.getElementById("content");
  return null;
}

function setBlankTarget(contentDocument, tagName){
  var alist = contentDocument.getElementsByTagName(tagName);
  for(i=0; i<alist.length; i++){
    var a = alist.item(i);
    a.target = "_blank";
  }
}

function tabloc(){
  var contentBrowser = getContentBrowser();
  if(!contentBrowser){ return; }
  var browser = contentBrowser.selectedBrowser;
  if(!browser){ return; }
  var contentDocument = browser.contentDocument;
  if(!contentDocument){ return; }
  setBlankTarget(contentDocument, "a");
  setBlankTarget(contentDocument, "form");
  setBlankTarget(contentDocument, "link");
  setBlankTarget(contentDocument, "area");
  contentBrowser.selectedTab.setAttribute("image", "chrome://tabloc/content/pin.png");
}

function addTabLockMenuItem () {
  var contentBrowser = getContentBrowser();
  if(!contentBrowser){ return; }
  var tabLockMenu = document.getElementById("tablocmenu").cloneNode(false);
  if(!tabLockMenu){ return; }

  tabLockMenu.id = "tab-tabloc";
  contentBrowser.mStrip.firstChild.nextSibling.insertBefore(tabLockMenu,
     contentBrowser.mStrip.firstChild.nextSibling.childNodes[2]);

  contentBrowser.tabContainer.addEventListener("dblclick", function(evt){
    tabloc();
  },false);
}
